# -*- coding: utf-8 -*-
#
# PyTblViewer
# SYMBIAN_UID = 0x
# masa
# (c) 2014 masa
__script__  = "PyTblViewer"
__version__ = "1.00(0)"
__copy__    = "masa"
__web__     = "http://masaland.cocolog-nifty.com/"


import sys, os
sys.setdefaultencoding('utf-8')
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')

import appuifw, globalui
import e32
import re

#-----------------------------------------
# configration data
Ini_file = 'E:\\Data\\Masa\\PyTblViewer.ini'
Path_default = 0
# Path_default  0:None   1:Tab   2:Comma   3:Space
Def_in_path = 'E:\\Data\\Dos\\1QK\\qmonth.tx_'
Def_out_path = 'D:\\qmonth.htm'
Font_size = 2
Table_border = 0
File_type_query = 1
#-----------------------------------------


lock = e32.Ao_lock()

try:
    import japanese
    JP_CODECS = 1
except:
    JP_CODECS = 0

try:
    from PyFbuiutil import Fbrowser
    from PyFbuiutil import Getpath
    Gpath = Getpath()
    FBUIUTIL = 1
except:
    FBUIUTIL = 0


def conf_read():
    global Ini_file
    global Path_default
    global Def_in_path
    global Def_out_path
    global Font_size
    global Table_border
    global File_type_query

    FData = 'Dummy Dummy'
    try:
        F = open(Ini_file,'r')
        try:
            FData = F.read()
        finally:
            F.close()
    except:
        pass

    #split by \n and omit line that contain only (CR/LF)
    lnDatalist = [x for x in FData.split("\n") if len(x) > 1]

    for lnData in lnDatalist:
        lnDatawk = re.sub("[ \t]+"," ",lnData)
        confData = lnDatawk.split(" ")
        if   len(confData) < 2: continue # no confData[1] line

        elif confData[0].lower() == "path_default" : Path_default = int(confData[1])
        elif confData[0].lower() == "def_in_path"  : Def_in_path = confData[1]
        elif confData[0].lower() == "def_out_path" : Def_out_path = confData[1]
        elif confData[0].lower() == "font_size"    : Font_size = int(confData[1])
        elif confData[0].lower() == "table_border" : Table_border = int(confData[1])
        elif confData[0].lower() == "file_type_query" : File_type_query = int(confData[1])
    error_flg = 0
    if Path_default > 3:
        Path_default = 0
        error_flg = 1
    if Font_size > 5 or Font_size < 1:
        Font_size = 2
        error_flg = 1
    if error_flg == 1:
        appuifw.query(unicode('Path_default または Font_size 設定誤りです。','UTF-8'), 'query')


def cvt_to_html():
    # Path_default  0:None   1:Tab   2:Comma   3:Space
    # delimiter_id           0:Tab   1:Comma   2:Space
    #
    if Path_default:
        open_path = Def_in_path
        delimiter_id = Path_default - 1
    else:
        dir_path = os.path.split(Def_in_path)[0]
        open_path = Gpath.get_read_path(default_path = dir_path)
        if not open_path:
            refresh()
            return
        if File_type_query == 1:
            m = [unicode('タブ区切り'), unicode('カンマ区切り'), unicode('スペース区切り')]
            delimiter_id = appuifw.popup_menu(m)
            if delimiter_id == None:
                refresh()
                return
        else:
            path_ext = (os.path.splitext(open_path)[1]).lower()
            if   path_ext == '.tsv': delimiter_id = 0
            elif path_ext == '.csv': delimiter_id = 1
            else                   : delimiter_id = 2

    wk2 = []
    Fi = open(open_path, 'r')
    FData = Fi.read()
    Fi.close()

    Enc, FData_uni = check_encode(FData) #use Enc

    lnDatalist = [x.strip(u" ") for x in FData_uni.split(u"\n")] # if len(x) > 1]

    for lnData in lnDatalist:
        if lnData[:10] == u'----------':
            continue

        if delimiter_id == 0: # id==0, tab
            col_list = [re.sub(u"[ \"]+$" ,u"" , (re.sub(u"^[ \"]+", u"", (x.strip())))) for x in lnData.split(u'\t')]
        elif delimiter_id == 2: # id==2, space
            lnData = re.sub(u"[ \t]+",u" ",lnData)
            col_list = lnData.split(u" ")
        else: # id==1, comma
            in_qtseq = 0 #flag, if in "" in_qtseq=1
            lnDataWK = ''
            for n in range(len(lnData)):
                if in_qtseq == 1:
                    if lnData[n] == u'"':
#                        lnDataWK = lnDataWK + u' ' #no need, (delete '"')
                        in_qtseq = 0
                    elif lnData[n] == u',':
                        lnDataWK = lnDataWK + u"\u21b2"
                    else:
                        lnDataWK = lnDataWK + lnData[n]
                else:
                    if lnData[n] == u'"':
#                        lnDataWK = lnDataWK + u' ' #no need, (delete '"')
                        in_qtseq = 1
                    else:
                        lnDataWK = lnDataWK + lnData[n]
            col_list = [re.sub(u"\u21b2", u",", (x.strip())) for x in lnDataWK.split(u",")]

        list_len = len(col_list)
        wk2.append('<TR>')
        if list_len == 1 and not col_list[0]: #改行のみの行
            wk2.append('  <TD align="right"><FONT size="%s">-</FONT></TD>' % Font_size)
            wk2.append('</TR>')
            continue
        for n in range(list_len):
            wk2.append('  <TD nowrap align="right"><FONT size="%s">%s</FONT></TD>' % (Font_size, col_list[n].encode(Enc)))
        wk2.append('</TR>')

    wk1 = ['<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">',
           '<HTML>',
           '<HEAD>',
           '<META http-equiv="Content-Type" content="text/html; charset=%s">' % Enc,
           '<META name="GENERATOR" content="IBM WebSphere Studio Homepage Builder Version 9.0.3.0 for Windows">',
           '<META http-equiv="Content-Style-Type" content="text/css">',
           '<TITLE></TITLE>',
           '</HEAD>',
           '<BODY>',
           '<TABLE border="%s">' % Table_border,
           '<COL span="1" align="right">',
           '<TBODY>']

    wk3 = ['</TBODY>',
           '</TABLE>',
           '</BODY>',
           '</HTML>']

    try:
        Fo = open(Def_out_path, 'w')
        for x in wk1:
            Fo.write(x+'\n')
        for x in wk2:
            Fo.write(x+'\n')
        for x in wk3:
            Fo.write(x+'\n')
        Fo.close()
    except:
        msg = '！！ ファイル出力時エラーがありました'
        rtn = globalui.global_msg_query(unicode(msg, "utf-8"), unicode("結果", "utf-8"))
        return

    try:
        e32.start_exe('BrowserNG.exe', ' "file:///%s"' % Def_out_path, 1)
    except:
        pass #show_er_val(3)

    refresh()


def check_encode(text_data, encoding=None):
    if encoding : enc_list = [encoding]
    else        : enc_list = ["UTF-8", "Shift-JIS"]

    for enc in enc_list:
        try:
            new_data = text_data.decode(enc)
            Enc = enc
            break
        except:
            pass
    else:
        if encoding : Enc = encoding
        else        : Enc = "UTF-8"
        try:
            new_data = text_data.decode(Enc, "replace")
        except: # may be never come here
            Enc = "UTF-8"
            new_data = u'text decode error occured'
#    new_data = text_data[:]
    return Enc, new_data


def set_font_size():
    global Font_size
    m = [u" Size= 1", u" Size= 2", u" Size= 3", u" Size= 4", u" Size= 5"]
    if Font_size < 6:
        m[Font_size-1] = u"*"+m[Font_size-1][1:]
    size_id = appuifw.popup_menu(m)
    if size_id == None: return
    Font_size = size_id + 1


def set_table_border():
    global Table_border
    m = [u" Border= 0", u" Border= 1"]
    if Table_border < 2:
        m[Table_border] = u"*"+m[Table_border][1:]
    border_id = appuifw.popup_menu(m)
    if border_id == None: return
    Table_border = border_id


def set_type_query():
    global File_type_query
    m = [u" By extension", u" Show query"]
    if File_type_query < 2:
        m[File_type_query] = u"*"+m[File_type_query][1:]
    id = appuifw.popup_menu(m)
    if id == None: return
    File_type_query = id


def refresh():
    list_wk = [unicode(__script__ + ' V' + __version__, 'UTF-8')]
    LISTBOX = appuifw.Listbox(list_wk, do_dummy)
    appuifw.app.body = LISTBOX
    appuifw.app.menu = [(unicode("ファイル","utf-8"), cvt_to_html),
                        (unicode("オプション", "utf-8"),
                         ((unicode("文字サイズ","utf-8"), set_font_size),
                          (unicode("テーブル枠幅","utf-8"), set_table_border),
                          (unicode("ファイルタイプ","utf-8"), set_type_query))),
                        (unicode("終了","utf-8"), appExit) ]
    appuifw.app.exit_key_handler = lambda:appExit() #lock.signal()#do_dummy()
    e32.ao_yield() # 画面反映


def do_dummy():
    pass


def appExit():
    lock.signal()


def main():
    """メインの関数"""
    oldtitle = appuifw.app.title
    appuifw.app.title = unicode(__script__, "utf-8")
    refresh()

    if JP_CODECS:
        conf_read()
        if FBUIUTIL or Path_default:
            cvt_to_html()
            lock.wait()
        else:
            appuifw.note(unicode('PyFbuiutilモジュールが見つかりません。\n終了します。','UTF-8'), 'error')
    else:
        appuifw.note(unicode('japaneseモジュールが見つかりません。\n終了します。','UTF-8'), 'error')
    appuifw.app.title = oldtitle


if __name__ == '__main__':
    main()

#    appuifw.app.set_exit()
#    sys.exit()

